#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Souris.ico
#AutoIt3Wrapper_Res_Description=Statistiques de la souris
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Silvere
#AutoIt3Wrapper_Res_Language=1036
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <File.au3>

Global $FenetreAfficher = True, $FichierSkin = @ScriptDir & "\Skins.txt", $FicherSauvegarde = @ScriptDir & "\Sauvegarde.txt", $Skin = 0, $Pixel = FileReadLine($FicherSauvegarde, 2)
Global $OldPosSouris = MouseGetPos(), $Array = GetResolution(), $Time = TimerInit(), $NbrCliqueDroit = FileReadLine($FicherSauvegarde, 3), $NbrCliqueGauche = FileReadLine($FicherSauvegarde, 4)

$LargeurResolution = $Array[2]


If Not FileExists($FicherSauvegarde) Then _FileCreate($FicherSauvegarde)

If NombreSkin() = 0 Then
	MsgBox(0, "", "Aucun Skin trouv")
	Exit
EndIf

AdlibRegister("SkinSuivant", 1000 * 60)

Opt("TrayMenuMode", 1)


Global $Gui = GUICreate("", 180, 150, -1, -1, $WS_POPUP, -1, WinGetHandle("[CLASS:Progman]"))

Global $ImgBackground = GUICtrlCreatePic("", 0, 0, 180, 150)
GUICtrlSetState(-1, $GUI_DISABLE)

Global $Exit = GUICtrlCreateLabel("X", 160, 0, 15, 20)
Global $Minimise = GUICtrlCreateLabel("_", 145, -8, 30, 30)
Global $HautDeFenetre = GUICtrlCreateLabel("Sourismtre", 0, 0, 140, 25, $SS_CENTER)
Global $CliqueGauche = GUICtrlCreateLabel("Clique gauche : " & $NbrCliqueGauche, 5, 25, 180, 25)
Global $CliqueDroit = GUICtrlCreateLabel("Clique droit : " & $NbrCliqueDroit, 5, 55, 180, 25)
Global $Metres = GUICtrlCreateLabel("Mtres : " & Round(PixelEnCM($Pixel), 2) / 100, 5, 85, 180, 25)
Global $MetresMin = GUICtrlCreateLabel("Mtres/Min : " & Round(PixelEnCM($Pixel) / 100 / Execute(FileReadLine($FicherSauvegarde, 1)) / 60000, 2), 5, 115, 180, 25)

SkinSuivant()
GUISetState()


While 1
	Souris()

	If _IsPressed("01") Then

		$NbrCliqueGauche = $NbrCliqueGauche + 1
		GUICtrlSetData($CliqueGauche, "Clique gauche : " & $NbrCliqueGauche)
		Sauvegarde()
		Do
			Souris()
			DeplacementFentenetre()
		Until Not _IsPressed("01")
	ElseIf _IsPressed("02") Then

		$NbrCliqueDroit = $NbrCliqueDroit + 1
		GUICtrlSetData($CliqueDroit, "Clique droit : " & $NbrCliqueDroit)
		Sauvegarde()
		Do
			Souris()
			DeplacementFentenetre()
		Until Not _IsPressed("02")
	EndIf
	DeplacementFentenetre()
	Switch GUIGetMsg()
		Case $Exit
			Exit
		Case $Minimise
			$FenetreAfficher = False
			GUISetState(@SW_HIDE)
	EndSwitch

	If TrayGetMsg() = -7 Then
		If $FenetreAfficher = False Then
			GUISetState()
			$FenetreAfficher = True
		Else
			GUISetState(@SW_HIDE)
			$FenetreAfficher = False
		EndIf
	EndIf
WEnd


;=====Fonctions=====

Func Souris()
	Local $PosSouris = MouseGetPos()
	If $PosSouris[0] <> $OldPosSouris[0] Or $PosSouris[1] <> $OldPosSouris[1] Then

		If $PosSouris[0] > $OldPosSouris[0] Then
			$Pixel = $Pixel + $PosSouris[0] - $OldPosSouris[0]
		EndIf
		If $PosSouris[0] < $OldPosSouris[0] Then
			$Pixel = $Pixel + $OldPosSouris[0] - $PosSouris[0]
		EndIf

		If $PosSouris[1] > $OldPosSouris[1] Then
			$Pixel = $Pixel + $PosSouris[1] - $OldPosSouris[1]
		EndIf
		If $PosSouris[1] < $OldPosSouris[1] Then
			$Pixel = $Pixel + $OldPosSouris[1] - $PosSouris[1]
		EndIf
		Sauvegarde()
		GUICtrlSetData($Metres, "Mtres : " & Round(PixelEnCM($Pixel) / 100, 2))
		GUICtrlSetData($MetresMin, "Mtres/Min : " & Round(PixelEnCM($Pixel) / 100 / Execute(FileReadLine($FicherSauvegarde, 1) / 60000), 2))
		$OldPosSouris = MouseGetPos()
	EndIf
EndFunc   ;==>Souris

Func SkinSuivant()
	If $Skin = NombreSkin() Then
		$Skin = 1
	Else
		$Skin = $Skin + 1
	EndIf

	ChangeSkin(IniRead($FichierSkin, "Skin " & $Skin, "Background", ""), IniRead($FichierSkin, "Skin " & $Skin, "Couleur", ""), IniRead($FichierSkin, "Skin " & $Skin, "Police", ""), IniRead($FichierSkin, "Skin " & $Skin, "TaillePolice", ""))
EndFunc   ;==>SkinSuivant

Func Sauvegarde()
	_FileWriteToLine($FicherSauvegarde, 1, FileReadLine($FicherSauvegarde, 1) + TimerDiff($Time), 1)
	_FileWriteToLine($FicherSauvegarde, 2, $Pixel, 1)
	_FileWriteToLine($FicherSauvegarde, 3, $NbrCliqueDroit, 1)
	_FileWriteToLine($FicherSauvegarde, 4, $NbrCliqueGauche, 1)
	$Time = TimerInit()
EndFunc   ;==>Sauvegarde


Func DeplacementFentenetre()
	Local $CursorInfo = GUIGetCursorInfo($Gui)

	If Not @error And $CursorInfo[4] = $HautDeFenetre And _IsPressed("01") Then
		Local $OldPosSouris = MouseGetPos()
		Do
			Local $PosSouris = MouseGetPos()
			If $PosSouris[0] <> $OldPosSouris[0] Or $PosSouris[1] <> $OldPosSouris[1] Then
				$PosGui = WinGetPos($Gui)
				WinMove($Gui, "", $PosGui[0] + $PosSouris[0] - $OldPosSouris[0], $PosGui[1] + $PosSouris[1] - $OldPosSouris[1])
			EndIf
			Local $OldPosSouris = MouseGetPos()
			Souris()
		Until $CursorInfo[4] <> $HautDeFenetre Or Not _IsPressed("01")
	EndIf
EndFunc   ;==>DeplacementFentenetre

Func ChangeSkin($Background, $Color, $Police, $TaillePolice)
	GUICtrlSetImage($ImgBackground, $Background)

	GUICtrlSetFont($HautDeFenetre, $TaillePolice, 400, 0, $Police)
	GUICtrlSetColor($HautDeFenetre, $Color)
	GUICtrlSetBkColor($HautDeFenetre, $GUI_BKCOLOR_TRANSPARENT)

	GUICtrlSetFont($CliqueGauche, $TaillePolice, 400, 0, $Police)
	GUICtrlSetColor($CliqueGauche, $Color)
	GUICtrlSetBkColor($CliqueGauche, $GUI_BKCOLOR_TRANSPARENT)


	GUICtrlSetFont($CliqueDroit, $TaillePolice, 400, 0, $Police)
	GUICtrlSetColor($CliqueDroit, $Color)
	GUICtrlSetBkColor($CliqueDroit, $GUI_BKCOLOR_TRANSPARENT)

	GUICtrlSetFont($Metres, $TaillePolice, 400, 0, $Police)
	GUICtrlSetColor($Metres, $Color)
	GUICtrlSetBkColor($Metres, $GUI_BKCOLOR_TRANSPARENT)

	GUICtrlSetFont($MetresMin, $TaillePolice, 400, 0, $Police)
	GUICtrlSetColor($MetresMin, $Color)
	GUICtrlSetBkColor($MetresMin, $GUI_BKCOLOR_TRANSPARENT)

	GUICtrlSetFont($Exit, 14, 400, 0, "MS Sans Serif")
	GUICtrlSetBkColor($Exit, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetColor($Exit, $Color)

	GUICtrlSetFont($Minimise, 22, 400, 4, "MS Sans Serif")
	GUICtrlSetBkColor($Minimise, $GUI_BKCOLOR_TRANSPARENT)
	GUICtrlSetColor($Minimise, $Color)

EndFunc   ;==>ChangeSkin



Func PixelEnCM($Pixel)
	Local $LargeurEcrant = 33 ; /!\Pour mon ordi/!\ ( En cm)
	Return $Pixel / Execute($LargeurResolution / $LargeurEcrant)
EndFunc   ;==>PixelEnCM

Func NombreSkin()
	Local $i
	Do
		$i = $i + 1
	Until IniRead($FichierSkin, "Skin " & $i, "Background", "") = ""
	Return $i - 1
EndFunc   ;==>NombreSkin



Func GetResolution($display = "")
	Local $res[4] = [0, 0, 0, 0], $i = 0, $n = 0
	While 1
		Local $struct = DllStructCreate("dword cb;char DeviceName[32];char DeviceString[128];dword StateFlags;char DeviceID[128];char DeviceKey[128]")
		DllStructSetData($struct, "cb", DllStructGetSize($struct))
		Local $displays = DllCall("user32.dll", "int", "EnumDisplayDevices", "ptr", 0, "dword", $i, "ptr", DllStructGetPtr($struct), "dword", 0)
		If Not $displays[0] Then ExitLoop
		If StringRegExp(DllStructGetData($struct, "DeviceName"), $display) And Not BitAND(DllStructGetData($struct, "StateFlags"), 0x00000008) Then
			Local $infos = DllStructCreate("char dmDeviceName[32];ushort dmSpecVersion;ushort dmDriverVersion;short dmSize;" & _
					"ushort dmDriverExtra;dword dmFields;long x;long y;dword dmDisplayOrientation;dword dmDisplayFixedOutput;" & _
					"short dmColor;short dmDuplex;short dmYResolution;short dmTTOption;short dmCollate;" & _
					"byte dmFormName[32];ushort LogPixels;dword dmBitsPerPel;int dmPelsWidth;dword dmPelsHeight;" & _
					"dword dmDisplayFlags;dword dmDisplayFrequency")
			DllStructSetData($infos, "dmSize", DllStructGetSize($infos))
			$displays = DllCall("user32.dll", "int", "EnumDisplaySettings", "str", DllStructGetData($struct, "DeviceName"), "dword", -1, "ptr", DllStructGetPtr($infos))
			Local $x0 = DllStructGetData($infos, "x"), $y0 = DllStructGetData($infos, "y"), $w = DllStructGetData($infos, "dmPelsWidth"), $h = DllStructGetData($infos, "dmPelsHeight")
			Local $x1 = $x0 + $w, $y1 = $y0 + $h
			If $w > 0 And $h > 0 Then
				If $res[0] > $x0 Then $res[0] = $x0
				If $res[1] > $y0 Then $res[1] = $y0
				If $res[2] < $x1 Then $res[2] = $x1
				If $res[3] < $y1 Then $res[3] = $y1
				$n += 1
			EndIf
		EndIf
		$i += 1
	WEnd
	$res[2] = $res[2] - $res[0]
	$res[3] = $res[3] - $res[1]
	SetExtended($n)
	Return $res
EndFunc   ;==>GetResolution

